% This function runs the NEL n_times and compute the average results
function MyNEL_multiLabels_activity_2(d,seqLen,originDataFileName,originLabelFileName,...
        W,MagicScore,Tfactor,offlineLearn,showDen,showTopK,showResults,...
        n_times,normalizeFunction,varargin)
        
    
    %Run n_times;
    D = cell(n_times,1);
    S = cell(n_times,1);
    N_denData = zeros(n_times,1);
    for runNum = 1:n_times
        stream_data = importdata(fullfile(d,originDataFileName));
        stream_labels = importdata(fullfile(d,originLabelFileName));
        dest = fullfile(d,['results_' num2str(runNum)]);
        if(~exist(dest,'dir'))
            mkdir(dest);
        end
        save(fullfile(dest,'stream_data.mat'),'stream_data');
        save(fullfile(dest,'stream_labels.mat'),'stream_labels');
        % pattern discovery       
        dataFileName = fullfile(['results_' num2str(runNum)], 'stream_data.mat');
        labelFileName = fullfile(['results_' num2str(runNum)], 'stream_labels.mat');
        [Dict,~,~,stats,n_denData] = mainFile_multiLabels_v4(d,seqLen,dataFileName,...
            labelFileName,W,MagicScore,Tfactor,offlineLearn,showDen,...
            showTopK,showResults,runNum);
        D{runNum} = Dict;
        S{runNum} = stats;
        N_denData(runNum) = n_denData;
    end

    %compute average statistics
     % initialize sumStats
    perf.totalNum = 0;
    perf.tp = 0;
    perf.fp = 0;
    perf.detectTimes = 0; 
    stream_labels = importdata(fullfile(d,originLabelFileName));
    uniLabels = unique(stream_labels);
    sumStats = containers.Map(uniLabels(1),perf);
    for i = 2:length(uniLabels)
        sumStats(uniLabels(i)) = perf;
    end
     % sumStats over all runs for each class   
    for i = 1:length(S)
        stats = S{i};
        labels = keys(stats);
        for j = 1:length(labels)
            if(labels{j} ~= -1) %ignore inconsistent case
                subperf = stats(labels{j});
                perf = sumStats(labels{j});
                perf.detectTimes = perf.detectTimes + 1;
                perf.tp = perf.tp + subperf.tp;
                perf.fp = perf.fp + subperf.fp;
                perf.totalNum = perf.totalNum + subperf.totalNum;
                sumStats(labels{j}) = perf;
            end
        end
    end
    
    % save results
    dest = fullfile(d,'final_results');
    if(~exist(dest))
        mkdir(dest);
    end
    save(fullfile(dest,sprintf('sumStats_size%d_score%2.2f_Tfactor%d.mat',W,MagicScore,Tfactor)),'sumStats');
    
    % print results to file
    if(~isempty(varargin))
        fid = fopen(varargin{1},'w');
        fclose(fid);
        % show the average results
        showResults_sumStats(sumStats,varargin);
        % show the stats for each run
        fid = fopen(varargin{1},'a');
        fprintf(fid,'\r\n\r\n\r\n');
        for j = 1:2
            fprintf(fid,'\r\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~');
            fprintf(fid,'\r\nDETAILS: summary results from each run');
            fprintf(fid,'\r\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~');
        end
        fprintf(fid,'\r\n\r\n\r\n');
        fclose(fid);
        for i = 1:n_times
            Dict = D{i};
            stats = S{i};
            fid = fopen(varargin{1},'a');
            fprintf(fid,['\r\n\r\n\r\n\r\nRun_' num2str(i)]);
            fclose(fid);
            showResults_stats(stats,seqLen,varargin);
        end
        % show the stats for each run
        fid = fopen(varargin{1},'a');
        fprintf(fid,'\r\n\r\n\r\n');
        for j = 1:2
            fprintf(fid,'\r\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~');
            fprintf(fid,'\r\nDETAILS: dictionary details from each run');
            fprintf(fid,'\r\n~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~');
        end
        fprintf(fid,'\r\n\r\n\r\n');
        fclose(fid);
        for i = 1:n_times
            Dict = D{i};
            stats = S{i};
            fid = fopen(varargin{1},'a');
            fprintf(fid,['\r\n\r\n\r\n\r\nRun_' num2str(i)]);
            fclose(fid);
            showResults_Dict(Dict,varargin);
        end
    end
        
    % print results to screen and plot figures
    if(showResults == 1)
        clc;close all;
        stream_data = importdata(fullfile(d,dataFileName));
        for i = 1:n_times
            Dict = D{i};
            stats = S{i};
            display(sprintf(['\r\n\r\nRun_' num2str(i)]));   
            %plotResults_Dict_v1(Dict,stream_data,seqLen);  
            plotResult_stats(stats,stream_data,seqLen,6);
            showResults_Dict(Dict);
            showResults_stats(stats,seqLen);
        end
        display('\n\n\n');  
        showResults_sumStats(sumStats);
    end
end







