function NNDist = computeMeanStd( data, seqLength, sizeDendro, maxCount, N, plotHist)
    n = length(data)-seqLength+1;
    NNDist = [];
    for i= 1:maxCount-1
        dis = zeros(1,N+1);
        j = 0;
        while j<=N
            j = j+1;
            r = randperm(n);
            temp = [];
            kk = 1;
            for k=1:sizeDendro
                sigma = 0;
                while(sigma == 0 & kk < length(r))
                    ts = data(r(kk):r(kk)+seqLength-1);
                    [ts, mu,sigma] = zscore(ts);
                    kk = kk + 1;
                end
                temp(k,:) = zscore(ts);
                if mod(k,2)==0
                    temp(k,:)=fliplr(temp(k,:));
                else
                    temp(k,:)=1-temp(k,:);
                end
            end
            z = linkage(temp,'single','euclidean');
            node = [];
            for k=1:size(z,1)
                node(k).ObjectID = [];
                if z(k,1)>sizeDendro
                    node(k).ObjectID = [node(k).ObjectID, node(z(k,1)-sizeDendro).ObjectID];
                else
                    node(k).ObjectID = [node(k).ObjectID, z(k,1)];
                end
                if z(k,2)>sizeDendro 
                    node(k).ObjectID = [node(k).ObjectID, node(z(k,2)-sizeDendro).ObjectID];
                else
                    node(k).ObjectID = [node(k).ObjectID, z(k,2)];
                end
                if length(node(k).ObjectID)==i+1
                    dis(j) = z(k,3);
                    break;
                end
            end 
          
            if dis(j)==0
                j=j-1;
                continue;
            end
        end
        NNDist(i,1) = mean(dis);
        NNDist(i,2) = std(dis,1);
        if plotHist
            figure;
            bins =round((max(dis)-min(dis))/0.25);
            hist(dis,bins);
            xlim([-inf, inf]);
            line([NNDist(i,1), NNDist(i,1)],[0 10],'color','r');
            line([NNDist(i,1)+NNDist(i,2), NNDist(i,1)+NNDist(i,2)],[0 10],'color','g');
            title(strcat('leaf is: ',num2str(i+1),' mean is: ',num2str(NNDist(i,1)), ' std is: ',num2str(NNDist(i,2))));
        end
    end
%     fileName = strcat('MEAN-STD_',name,'_',num2str(seqLength),'_',num2str(sizeDendro),'_',num2str(maxCount),'_',num2str(N),'.txt');
%     fid = fopen(fileName,'w');
%     for i= 1:maxCount-1
%         fprintf(fid,'%f\t%f\t',NNDist(i,:));
%         fprintf(fid,'\n');
%     end
%     fclose(fid);
end