function [totalNum,validTp,validFp] = countValidStatistics(stream_labels,concept,seqLen)
%%%% assumption: the step size must be no more than the subsequence size

    % totalNum
    inds = find(stream_labels(:,1) == concept.label);
    inds = getNonOverlap(inds,seqLen);
    inds = inds(find(inds > concept.pos(1)));
    totalNum = length(inds);
    
    % find valid fp
    errorIdx = concept.dataIdx(find(concept.correct == 0));
    validFp = getNonOverlap(errorIdx,seqLen);
    
    % find valid tp: if multiple fps belonging to a same data, choose the one
    % that is closest to the template
    validTp = [];
    correctIdx = concept.dataIdx(find(concept.correct == 1));
    correctDis = concept.dataDis(find(concept.correct == 1));
    if(isempty(inds))
        validTp = [];
        return;
    end
    correctIdx = correctIdx(find(correctIdx >= inds(1)));
    correctDis = correctDis(find(correctIdx >= inds(1)));
    for i = 1:length(inds)
        range_begin = max(1,inds(i)-seqLen+1);
        range_end = min(length(stream_labels(:,1)),inds(i)+seqLen-1);
        if(i < length(inds) & inds(i+1)-inds(i)==seqLen) % consecutive
            range_end = inds(i)-1+ floor(seqLen/2);
        end
        if(i > 1 & inds(i)-inds(i-1)==seqLen)
            range_begin = inds(i)-floor(seqLen/2);
        end
        range = range_begin : range_end;
        flags = ismember(correctIdx,range);
        pos = correctIdx(flags);
        dis = correctDis(flags);
        if(length(dis)>0)
            [~,idx] = min(dis);
            validTp = [validTp,pos(idx)];
        end
    end
    
end