% different from denScore:
% (1) now the score is positive, and sort in descending order
% (2) resolve the bug, so that subtree larger than threshold never gets into topK
% (3) plot only when show == 1

function [Idx, Idx_children,sortedSubtrees,Z] = denScore_Ping(X,Y,M,S,P,threshold,show)
    
    cell_x = cell(1,size(X,1));
    for i = 1: size(X,1)
        cell_x{i} = X(i,:);
    end
    Z = linkage(Y,'average');

    % based on the linkage, return all the subtrees; 
    % for each subtree, return its root, immediate children, linkage distance
    % all its leaf children, internal children, and its parent and ancesters 
    [~,~,Idx,Idx_children] = dendrogram_Ping(Z,cell_x,show,P);

    
    % compute the score for each subtree
    score = zeros(1,P-1);
     for i = 1: P-1
        if (Idx(i,4) >threshold)  % ignore subtrees that have more than threshold nodes(too big to consider) 
            continue;
        end
        r = Idx(i,4);
        val = Idx(i,5); % =Z(i,3)
        score(i) = (M(r)-val)/S(r);   
    end
    
    % sort the subtree in descending order, return their scores and root nodes
    sortedSubtrees = cell(1,2);
    [v,pos] = sort(score,'descend');
    for i = 1: length(pos)   
        sortedSubtrees{1} = [sortedSubtrees{1}, v(i)];
        sortedSubtrees{2} = [sortedSubtrees{2}, Idx(pos(i),3)]; % the root node of the subtrees
    end


