% (1) resolve a bug in plot. Always update the dendrogram when overflow and
% update score, so always show current score
function [items, score_val]=nell_report_2(show,K,sortedClusters,Idx_children,...
        buffer,len,index,no_plot,j,counter_increment)             
            
    grey = [0.8 0.8 0.8];
    if(show == 1)
        h =subplot(K/2,2,j);
    end
    if (no_plot)
        if(show == 1)
            title('NO VALID REPORT');
            cla(h);
        end
        items = [];
        score_val = NaN; % no previous score val
    else
        items = Idx_children{index-size(buffer,1),1};
        num_items = length(items);
        mean_ts = mean(buffer(items,:));
        
        if(show == 1)
            plot(1:len, buffer(items,:),'Color', grey,'LineWidth',2); % need to be znormalized
            hold on; 
            plot(1:len,mean_ts,'r', 'LineWidth',1);
            hold off;
        end
        [~,pos] = find(sortedClusters{2} == index);
        score_val = sortedClusters{1}(pos);
        
        if(show == 1)
            if(num_items >= 6)
                % see if counter increment is needed
                template = mean(items);
                d = zeros(1,size(counter_increment,1));
                for i = 1:size(counter_increment,1)
                    d(i) = computeED(template,counter_increment(i,1:end-1));
                    if(d(i) == 0)  
                        num_items = num_items + counter_increment(i,end);
                    end
                end
            end
            title(['Counter: ' num2str(num_items) ', Score: ' num2str(score_val)...
                    ', Node: ' num2str(index)]);
        end
    end
    
    
    % simple case
%     grey = [0.8 0.8 0.8];
%     subplot(K,1,index);
%     internal_node = topK{2};    
%     items = Idx_children{internal_node(index)-size(buffer,1)};
%     num_items = length(items);
%     plot(1:len, buffer(items,:),'Color', grey,'LineWidth',2);
% %     plot(1:len, buffer(items,:),'LineWidth',3);
%     hold on;
%     mean_ts = mean(buffer(items,:));
%     plot(1:len,mean_ts,'r', 'LineWidth',1);
%     hold off;
%     title(['Counter: ' num2str(num_items) ', Score: ' num2str(topK{1}(index))...
%         ', Node: ' num2str(internal_node(index))]);
     