function   plotResult_stats(stats,stream_data,seqLen,nPerPage)
    if(nargin < 4)
        nPerPage = 10;
    end
    labels = keys(stats);
    num = ceil(length(labels)/nPerPage);
    for k = 1:num
        figure;
        grey = [0.8 0.8 0.8];
        red = [1 0 0];
        legendFlag = 0;
        for i = (k-1)*nPerPage + 1 : min(k*nPerPage,length(labels))
            subplot(ceil(nPerPage/2),2,i - (k-1)*nPerPage);
            perf = stats(labels{i});
            if(labels{i}~=-1)
                %put legend
                if(perf.tp >0 & perf.fp>0 & ~legendFlag)
                    ts = stream_data(perf.validCorrectIdx(1) ...
                        : perf.validCorrectIdx(1)+seqLen-1);
                    plot(zscore(ts),'color',red);
                    hold on;
                    ts = stream_data(perf.validErrorIdx(1) ...
                        : perf.validErrorIdx(1)+seqLen-1);
                    plot(zscore(ts),'color',grey);
                    hold on;
                    legend('true positive','false positive');
                    legendFlag = 1;
                end
               for j = 1:length(perf.validErrorIdx)
                    ts = stream_data(perf.validErrorIdx(j)...
                         : perf.validErrorIdx(j)+seqLen-1);
                    plot(zscore(ts),'color',grey);
                    hold on;
                end
                for j = 1:length(perf.validCorrectIdx)
                    ts = stream_data(perf.validCorrectIdx(j) ...
                        : perf.validCorrectIdx(j)+seqLen-1);
                    plot(zscore(ts),'color',red);
                    hold on;
                end
 
                s = sprintf('class:%d, pos:%2.4f%%, varies:%d, total:%d, tp:%d, fp:%d',...
                    labels{i},perf.pos_percent,perf.variations,perf.totalNum,perf.tp,perf.fp); 
                title(s);
            else
                for j = 1:length(perf.validDataIdx)
                    ts = stream_data(perf.validDataIdx(j)...
                         : perf.validDataIdx(j)+seqLen-1);
                    plot(zscore(ts),'color',grey);
                    hold on;
                end
                title(sprintf('class:%d, pos:%2.4f%%, varies:%d, fp:%d',...
                    labels{i},perf.pos_percent,perf.detectedTimes,perf.nValidData));
            end
        end
    end
end
                
  