function plotResults_Dict_v1(Dict,stream_data,seqLen)
    % plot the first 10 classifiers
    num = ceil(length(Dict)/10);
    for k = 1:num
        figure;
        grey = [0.8 0.8 0.8];
        lightblue = [0 0 0.5];
        for i = (k-1)*10 + 1 : k*10
            subplot(5,2,i - (k-1)*10);
            if(length(Dict) >=i)
                % plot trainData
                for j = 1:length(Dict{i}.trainDataIdx)
                    ts = stream_data(Dict{i}.trainDataIdx(j) : Dict{i}.trainDataIdx(j)+seqLen-1);
                    plot(zscore(ts),'color',lightblue);
                    hold on;
                end
                % plot detected
                for j = 1:length(Dict{i}.dataIdx)
                    ts = stream_data(Dict{i}.dataIdx(j) : Dict{i}.dataIdx(j)+seqLen-1);
                    plot(zscore(ts),'color',grey);
                    hold on
                end
                % plot template
                plot(Dict{i}.template,'r');
                hold on;
                %title
                if( ~isequal(Dict{i}.label,-1))
                    if(~ischar(Dict{i}.label))
                        if(length(Dict{i}.label) == 1)
                            title(sprintf('concept: %d  pos=%2.2f%% tp=%d  fp=%d  total=%d',...
                                Dict{i}.label(1),Dict{i}.pos_percent,Dict{i}.tp,Dict{i}.fp,Dict{i}.totalNum));
                        else
                             title(sprintf('concept: %d,%d  pos=%2.2f%% tp=%d  fp=%d  total=%d',...
                                Dict{i}.label(1),Dict{i}.label(2),Dict{i}.pos_percent,Dict{i}.tp,Dict{i}.fp,Dict{i}.totalNum));
                   
                        end
                    else
                        if(length(Dict{i}.label) == 1)
                            title(sprintf('concept: %c  pos=%2.2f%% tp=%d  fp=%d  total=%d',...
                                Dict{i}.label(1),Dict{i}.pos_percent,Dict{i}.tp,Dict{i}.fp,Dict{i}.totalNum));
                        else
                            title(sprintf('concept: %c %c  pos=%2.2f%% tp=%d  fp=%d  total=%d',...
                                Dict{i}.label(1),Dict{i}.label(2),Dict{i}.pos_percent,Dict{i}.tp,Dict{i}.fp,Dict{i}.totalNum));
                        end
                    end
                else      
                    if(~ischar(Dict{i}.label))
                        title(sprintf('concept: %d  pos=%2.2f%% userlabels:%d, %d ...',...
                            Dict{i}.label(1),Dict{i}.pos_percent,Dict{i}.userlabels(1,1),Dict{i}.userlabels(2,1)));
                    else
                        title(sprintf('concept: %c  pos=%2.2f%% userlabels:%d, %d ...',...
                            Dict{i}.label(1),Dict{i}.pos_percent,Dict{i}.userlabels(1,1),Dict{i}.userlabels(2,1)));
                    end
                end
            else
                title('No Pattern');
            end
        end
    end
end