% when check if this object is correctly classified, we check the
% intersecton of the this object's labels with the class labels

function [flag_in,Dict,correct] = preprocess_multiLabels_v4(Dict,new_ts,i,trueLabel)
        
        flag_in = 1;
        correct = -1;
        seqLen = length(new_ts);
        
        % distance of new_ts to each template in dictionary
        dis = zeros(1,length(Dict));
        if(~isempty(Dict))
            for kk = 1: length(Dict)
                if(i < max(Dict{kk}.trainDataIdx)+ seqLen)
                    dis(kk) = inf;
                else
                    dis(kk) = pdist2(reshape(Dict{kk}.template,1,[]),reshape(new_ts,1,[]));
                    if(dis(kk) > Dict{kk}.threshold)
                        dis(kk) = inf;  %inf if new_ts is not belong to this class
                    end
                end
            end
        end
       
        % update only the class to which new_ts is nearest to
        [val,idx] = min(dis);
        
        if(val ~= inf)   % close to learned concept
            % find same templates, but different labels in dict
            stop = 0;
            kk = 1;
            cand_id = idx;
            while(~stop)
                temp = idx + kk;
                if(temp < length(dis) & dis(temp) == val)
                    cand_id = [cand_id temp];
                    kk = kk + 1;
                else
                    stop = 1;
                end
            end
            % for each template, check if it is the same label
            for k = 1:length(cand_id)
                if(~isempty(intersect(Dict{cand_id(k)}.label,trueLabel)))
                    idx = cand_id(k);
                    Dict{idx}.dataIdx = [Dict{idx}.dataIdx, i];
                    Dict{idx}.dataDis = [Dict{idx}.dataDis,val];
                    Dict{idx}.correct = [Dict{idx}.correct 1];
                    correct = 1;
                    flag_in = 0;
                    return;
                end
            end
            % if none is the same label, then it is misclassified
            idx = idx + (randi(length(cand_id))-1);
            Dict{idx}.dataIdx = [Dict{idx}.dataIdx, i];
            Dict{idx}.dataDis = [Dict{idx}.dataDis,val];
            Dict{idx}.correct = [Dict{idx}.correct 0];
            correct = 0;
        end
end