function showResults_Dict(Dict,varargin)
    n = 0;
    % print to screen
    if(isempty(varargin))
        disp(sprintf('\n'));
        disp('****************************************************');
        disp('*         Show Results from Dictionary             *');
        disp('****************************************************');
        for i = 1:length(Dict)
            display('===================================');
            display(i);
            if(iscell(Dict{i}.label))
                if(length(Dict{i}.label) ==2)
                    display(['class_label: ' Dict{i}.label{1} ',' Dict{i}.label{2}]);
                else
                    display(['class_label: ' Dict{i}.label{1}]);
                end
            elseif(ischar(Dict{i}.label))
                if(length(Dict{i}.label) ==2)
                    display(['class_label: ' Dict{i}.label(1) ',' Dict{i}.label(2)]);
                else
                    display(['class_label: ' Dict{i}.label(1)]);
                end
            else
                if(length(Dict{i}.label) ==2)
                    display(['class_label: ' num2str(Dict{i}.label(1)) ',' num2str(Dict{i}.label(2))]);
                else
                    display(['class_label: ' num2str(Dict{i}.label(1))]);
                end
            end
            correctIdx = Dict{i}.dataIdx(find(Dict{i}.correct == 1));
            errorIdx = Dict{i}.dataIdx(find(Dict{i}.correct == 0));
            display(['pattern discover postion:  ' num2str(Dict{i}.pos_percent) '%']);
            disp('All:');
            display(['true postives: ' num2str(correctIdx)]);
            display(['false positives: ' num2str(errorIdx)]);
            disp('Non-overlap:');
            display(['true postives: ' num2str(Dict{i}.validCorrectIdx)]);
             display(['false positives: ' num2str(Dict{i}.validErrorIdx)]);

            if(iscell(Dict{i}.label) & ~isequal(Dict{i}.label,'inconsistent') ...
                    | ~iscell(Dict{i}.label) & ~isequal(Dict{i}.label,-1))
                n = n + 1;
            end
        end
        display('=================');
        display(sprintf('percent of inconsistent: %2.2f%%', 100 * (1 - n/length(Dict))));
    
    % print to file
    else
        filename = char(varargin{1});
        fid = fopen(filename,'a');
        fprintf(fid,sprintf('\r\n'));
        fprintf(fid,'\r\n****************************************************');
        fprintf(fid,'\r\n*         Show Results from Dictionary             *');
        fprintf(fid,'\r\n****************************************************');
        for i = 1:length(Dict)
            fprintf(fid,'\r\n===================================');
            fprintf(fid,['\r\ni = ' num2str(i)]);
            if(iscell(Dict{i}.label))
                if(length(Dict{i}.label) ==2)
                    fprintf(fid,['\r\nclass_label: ' Dict{i}.label{1} ',' Dict{i}.label{2}]);
                else
                    fprintf(fid,['\r\nclass_label: ' Dict{i}.label{1}]);
                end
            elseif(ischar(Dict{i}.label))
                if(length(Dict{i}.label) ==2)
                    fprintf(fid,['\r\nclass_label: ' Dict{i}.label(1) ',' Dict{i}.label(2)]);
                else
                    fprintf(fid,['\r\nclass_label: ' Dict{i}.label(1)]);
                end
            else
                if(length(Dict{i}.label) ==2)
                    fprintf(fid,['\r\nclass_label: ' num2str(Dict{i}.label(1)) ',' num2str(Dict{i}.label(2))]);
                else
                    fprintf(fid,['\r\nclass_label: ' num2str(Dict{i}.label(1))]);
                end
            end
            correctIdx = Dict{i}.dataIdx(find(Dict{i}.correct == 1));
            errorIdx = Dict{i}.dataIdx(find(Dict{i}.correct == 0));
            fprintf(fid,['\r\npattern discover postion:  ' num2str(Dict{i}.pos_percent) '%']);
            fprintf(fid,'\r\nAll:');
            fprintf(fid,['\r\ntrue postives: ' num2str(correctIdx)]);
            fprintf(fid,['\r\nfalse positives: ' num2str(errorIdx)]);
            fprintf(fid,'\r\nNon-overlap:');
            fprintf(fid,['\r\ntrue postives: ' num2str(Dict{i}.validCorrectIdx)]);
            fprintf(fid,['\r\nfalse positives: ' num2str(Dict{i}.validErrorIdx)]);

            if(iscell(Dict{i}.label) & ~isequal(Dict{i}.label,'inconsistent') ...
                    | ~iscell(Dict{i}.label) & ~isequal(Dict{i}.label,-1))
                n = n + 1;
            end
        end
        fprintf(fid,'\r\n=================');
        fprintf(fid,sprintf('\r\npercent of inconsistent:%2.2f%%', 100 * (1 - n/length(Dict))));
        fclose(fid);
    end
        
end
