function  showResults_stats(stats,seqLen,varargin)
    labels = keys(stats);
    % print to screen
    if(isempty(varargin))
        disp(sprintf('\n'));
        display('******************************************************');
        disp   ('*        Summarize Results in Dictionary             *');
        display('******************************************************');
         for i = 1:length(stats)    
            perf = stats(labels{i});
            disp(sprintf('==========================================='));
            disp(['i = ' num2str(i)]);
            disp(['class label: '  num2str(labels{i})]);
            disp(['1st detect position: '  num2str(perf.pos_percent) '%']);
            if(labels{i} == -1)
                disp(['number of inconsistencys: ' num2str(perf.detectedTimes)]);
                disp(['number of classified data: ' num2str(perf.nValidData)]);
            else          
                disp(['---- detected results -----']);
                disp(['number of variations: ' num2str(perf.variations)]);
                disp(['total true positives: ' num2str(perf.totalNum)]);
                disp(['number of tps: ' num2str(perf.tp)]);
                disp(['number of fps: ' num2str(perf.fp)]);
                disp(['positions(tps): ' num2str(perf.validCorrectIdx)]);
                disp(['positions(fps): ' num2str(perf.validErrorIdx)]);
            end
         end
    % print to file
    else
        filename = char(varargin{1});
        fid = fopen(filename,'a');
        fprintf(fid,sprintf('\r\n'));
        fprintf(fid,sprintf('\n'));
        fprintf(fid,'\r\n******************************************************');
        fprintf(fid,'\r\n*        Summarize Results in Dictionary             *');
        fprintf(fid,'\r\n******************************************************');
        for i = 1:length(stats)    
            perf = stats(labels{i});
            fprintf(fid,sprintf('\r\n==========================================='));
            fprintf(fid,['\r\ni = ' num2str(i)]);
            fprintf(fid,['\r\nclass label: '  num2str(labels{i})]);
            fprintf(fid,['\r\n1st detect position: '  num2str(perf.pos_percent) '%%']);
            if(labels{i} == -1)
                fprintf(fid,['\r\nnumber of inconsistencys: ' num2str(perf.detectedTimes)]);
                fprintf(fid,['\r\nnumber of classified data: ' num2str(perf.nValidData)]);
            else     
                fprintf(fid,'\r\n---- detected results -----');       
                fprintf(fid,['\r\nnumber of variations: ' num2str(perf.variations)]);
                fprintf(fid,['\r\ntotal true positives: ' num2str(perf.totalNum)]);
                fprintf(fid,['\r\nnumber of tps: ' num2str(perf.tp)]);
                fprintf(fid,['\r\nnumber of fps: ' num2str(perf.fp)]);
                fprintf(fid,['\r\npositions(tps): ' num2str(perf.validCorrectIdx)]);
                fprintf(fid,['\r\npositions(fps): ' num2str(perf.validErrorIdx)]);
            end
        end
       fclose(fid);
        
end