
function showResults_sumStats(sumStats,varargin)
    % print to screen
    if(isempty(varargin))
        labels = keys(sumStats);
        disp(sprintf('\n'));
        display('******************************************************');
        disp   ('*          Summarize Results over Multi-runs         *');
        display('******************************************************');
        for i = 1:length(sumStats)    
            perf = sumStats(labels{i});
            disp(sprintf('==========================================='));
            disp(['i = ' num2str(i)]);
            disp(['class label: '  num2str(labels{i})]);
            disp(['number of detections(runs): ' num2str(perf.detectTimes)]);
            disp(['sum of total true positives: ' num2str(perf.totalNum)]);
            disp(['sum of true positives: ' num2str(perf.tp)]);
            disp(['sum of false positives: ' num2str(perf.fp)]);
        end
    
    % print to file
    else
        filename = char(varargin{1});
        fid = fopen(filename,'a');
        fprintf(fid,sprintf('\r\n'));
        labels = keys(sumStats);
        fprintf(fid,'\r\n******************************************************');
        fprintf(fid,'\r\n*          Summarize Results over Multi-runs         *');
        fprintf(fid,'\r\n******************************************************');
        for i = 1:length(sumStats)    
            perf = sumStats(labels{i});
            fprintf(fid,sprintf('\r\n==========================================='));
            fprintf(fid,['\r\ni = ' num2str(i)]);
            fprintf(fid,['\r\nclass label: '  num2str(labels{i})]);
            fprintf(fid,['\r\nnumber of detections(runs): ' num2str(perf.detectTimes)]);
            fprintf(fid,['\r\nsum of total true positives: ' num2str(perf.totalNum)]);
            fprintf(fid,['\r\nsum of true positives: ' num2str(perf.tp)]);
            fprintf(fid,['\r\nsum of false positives: ' num2str(perf.fp)]);
        end
        fclose(fid);
        
end