function new_counter =  update_counter(Idx,Idx_children,topK_cand,...
                        K,overflow_num,buffer,counter_increment)
    % counter only contains templates that satisfy the following condition:
    % (1) the subset is in current topK (if the subset is in prevous topK,
    %     but not current TopK, then it will NOT be in the counter.
    % (2) the size of subset reaches overflow_num(gonna to overflow)
    % the counter's value is:
    % (1) if this is a new template, let increment = 0;
    % (2) if this template is old(it's a current topK, but also a topK in 
    %     previous dendrograms), then, keep its increment unchanged
    
    new_counter = [];
    n = min(K,length(topK_cand));
    for i = 1:n
        [subtree_idx,~] = find(Idx(:,3) == topK_cand(i));
        leafs = Idx_children{subtree_idx,1};
        if(length(leafs)>= overflow_num)
            template = mean(buffer(leafs,:));
            increment = 0;
            for j = 1:size(counter_increment,1)
                d = computeED(template,counter_increment(j,1:end-1));
                if(d == 0)
                    increment = counter_increment(j,end);
                    break;
                end
            end
            new_counter = [new_counter; [template,increment]];
        end
    end