% (1) resolve a bug: tmp = topK{2}(topK{1}~= -10000);   
% (2) resolve second bug: after remove one valid node, the rest nodes should
%     observe the original sortedSubtrees order

function valid_node = validNode_v2(sortedSubtrees,Idx_children,Idx)
    % A valid node must be:
    % (1) no overflow  
    % (2) no parent all children after itself, but cousin is fine
    tmp = sortedSubtrees{2}(sortedSubtrees{1} ~= 0);               
    valid_node = [];

    while(~isempty(tmp))
        % take the current top1 subtree
        temp_node = tmp(1);
        valid_node = [valid_node, temp_node];
        
        % find the top1's parents and children
        subtree_idx = find(Idx(:,3) == temp_node); %find the subtree of which the root is temp_node       
        parent_temp = Idx_children{subtree_idx,3};
        child_temp = Idx_children{subtree_idx,2}; % only care about internal nodes
        join_temp = [parent_temp, child_temp];
        
        % remove the parents and children, and current top1
        tmp = tmp(~ismember(tmp,join_temp));
        tmp = tmp(2:end);  
    end
    

    